##' @param files
##' @param all.files
##' @param full.names
##' @param recursive

##' @return ...

assignFiles <- 
  function (files = list.files(pattern = ".txt",
              all.files = FALSE, 
              full.names = FALSE, recursive = FALSE),
            strip = "(_1|.txt|-| )", ...) 
{
  data <- list()
  variables <- gsub(strip, "", files)
  
    for (ii in (1:length(files))) {
      name <- files[ii]
      data[[ii]] <- read.csv(name, head=F, colClasses=c("numeric","integer","numeric"), ...)
      names(data[[ii]]) <- c("wavelength", "pixel", "value")
    }
  names(data) <- variables
  return(data)
}

##' @param d

##' @return ...
reshape <- function(d){
  lapply(d, function(.d){
         a <- cast(.d, wavelength~pixel)
         list(wavelength = a[, 1], 
              intensity = as.matrix(a[, -1]))
            })
}
